//funkce pouzivane pri importu dat z GPX souboru
//------------------------------------------------------------------------------
//deklarace funkci definovanych v jinych souborech
procedure SaveLab(idx:integer); forward; //LabForGg.fceForm.pas
procedure AddChangeType(sType:string); forward;     //LabForGg.fceForm.pas
//------------------------------------------------------------------------------
function PrintCmpIType(iCmpType:integer):string;
begin
  case iCmpType of
  0: Result:='neni ';
  1: Result:='LabId';
  2: Result:='COORD';
  3: Result:='NAME ';
  4: Result:='-!!!-'; //nepodarilo se urcit, poradi bylo prideleno podle "volnych" labek v gpx souboru
  else Result:='?????';
  end;
end;

procedure PrintCmpItem(rCmp:T_CMP_ITEM; sTxt:string);
begin
  Log(sTxt+'(shoda='+PrintCmpIType(rCmp.iCmpType)+') GC='+rCmp.sGc+', idx(krizem)='+IntToStr(rCmp.idx)+', LabIdOrd='+rCmp.sLabIdOrd+', '+rCmp.sCoord+', '+rCmp.sName);
end;

procedure PrintCmp(rCmp:T_CMP_SERIE; sText:string);
var i:integer;
begin
  sText:=sText+CRLF+'  Pocet labek: '+IntToStr(rCmp.nCount)+', serie: '+UtfToAnsi(rCmp.sSerieName)+' (jmena LABek malymi v ASCII)';
  if(rCmp.bCoord=false) then sText:=sText+', porovnani podle COORD zakazano, stejne souradnice u nekterych labek';
  Log(sText);
  for i:=0 to rCmp.nCount-1 do begin
    PrintCmpItem(rCmp.Items[i],'      '+IntToStr(i)+' => ');
  end;
end;

function GetGcListFromGpx(sGpx:string):string;
begin
  Result:='';
  while(sGpx<>'') do begin
    fetch(sGpx,'<name>');
    Result:=Result+Fetch(sGpx,'</name>')+CRLF;
  end;
  Result:=ReplaceString(Trim(Result),CRLF,',');
end;

function GetKeyForCategory(sCategory:string):integer;
var s:string;
begin
  Result:=-1;
  GEOGET_DB.AddParamText(':cat',sCategory);
  s:=GEOGET_DB.GetTableString('SELECT key FROM geotagcategory WHERE value=:cat');
  if(s<>'') then Result:=StrToInt(s);
end;

procedure RemoveFromList(sGCs:string);
var sFile:string;
begin
  sFile:=GetMyDir()+'sub.ggt';
  //{$ifdef DEBUG_HELPER} LDH('Odstranuji ze zobrazeneho seznamu: '+sListSub);{$endif}
  StringToFile(sGCs,sFile);
  GeoListFileSub(sFile);
  DeleteFile(sFile);
end;

procedure RemoveLabTags(sGc:string); //vymaze tagy, ktere se pri importu neprepisuji
var sSql:string;
begin
  //pokud neni zjisten klic kategorie LABsmartLink a LABflags, Zjistime ho
  if(iKeySmartLink=0) then iKeySmartLink:=GetKeyForCategory('LABsmartLink');
  if(iKeyFlags=0) then iKeyFlags:=GetKeyForCategory('LABflags');
  sSql:='DELETE FROM geotag WHERE id=:id AND ptrkat=:key';
  //pokud je hodnota klice -1, neexistuje a neni co odstranovat
  if(iKeySmartLink>0) then begin                //LABsmartLink
    //{$ifdef DEBUG_HELPER} LDH('Mazu LABsmartLink pro '+sGc+', key='+IntToStr(iKeySmartLink)); {$endif}
    GEOGET_DB.AddParamText(':id',sGc);
    GEOGET_DB.AddParamInt(':key',iKeySmartLink);
    GEOGET_DB.ExecSQL(sSql);
    //{$ifdef DEBUG_HELPER} LDH('Pocet zmen v databazi: '+IntToStr(GEOGET_DB.LastChangedRows()));
  end;
  if(iKeyFlags>0) then begin                   //vsechny priznakove tagy (HaveBonus, IsEvent, ...)
    //{$ifdef DEBUG_HELPER} LDH('Mazu LABflags pro '+sGc+', key='+IntToStr(iKeyFlags)); {$endif}
    GEOGET_DB.AddParamText(':id',sGc);
    GEOGET_DB.AddParamInt(':key',iKeyFlags);
    GEOGET_DB.ExecSQL(sSql);
    //{$ifdef DEBUG_HELPER} LDH('Pocet zmen v databazi: '+IntToStr(GEOGET_DB.LastChangedRows()));
  end;
end;

procedure SeqToDT(sFile:string);
var s,sGpx,sNew,sLabId,sVzor:string;
    n,i:integer;
    bChange:boolean;
begin
{$ifdef DEBUG_HELPER} LDH('Uprava GPX pro priznak sekvencni serie v D/T');{$endif}
  sGpx:=FileToString(sFile);
  bChange:=false;
  //pokud je treba, doplnime odkaz na XML data
  //if(LowerCase(GEOGET_OWNER)=LowerCase(ADD_XMLLINK)) then begin
  sVzor:='<gpxg:Tag Category="LABid"><![CDATA[';
  i:=Pos(sVzor,sGpx);
  sLabId:=copy(sGpx,i+Length(sVzor),36);
  sVzor:=AddLinks(sLabId);
  if(sVzor<>'') then begin
    sGpx:=ReplaceString(sGpx,'<hr>',sVzor);
    bChange:=true;
  end;
  //zvyraznit info o sekvencni serii
  sVzor:=AnsiToUtf('Srie m pedepsan poad odlovu.');
  if(Pos(sVzor,sGpx)>1) then begin
    sGpx:=ReplaceString(sGpx,sVzor+'<br>','<font color="red"><b>'+sVzor+'</b></font><br>');
//{$ifdef DEBUG_HELPER} LDH('GPX s odkazem na XML: '+sGpx);{$endif}
    bChange:=true;
  end;
  if(GgForm_bDT.Checked) then begin
    //pokud serie neni sekvencni, ukoncime se
    if(Pos('Category="LABflags"><![CDATA[IsSequential]]',sGpx)>1) then begin
      n:=1;
      sNew:='';
      while(sGpx<>'') do begin
        sNew:=sNew+Fetch(sGpx,'<groundspeak:difficulty>');
        if(sGpx='') then break;
        Fetch(sGpx,'<');
        //1,2,3,4,5,5,5,5,...
        if(n>5) then s:='5'
        else s:=IntToStr(n);
        Inc(n);
        sNew:=sNew+'      <groundspeak:difficulty>'+s+'<'+Fetch(sGpx,'<groundspeak:terrain>');
        Fetch(sGpx,'<');
        sNew:=sNew+'      <groundspeak:terrain>4<';
        bChange:=true;
      end;
    end;
  end
  else if(bChange) then sNew:=sGpx;
  if(bChange) then StringToFile(sNew,sFile); //prepiseme puvodni soubor
end;

procedure ChangeGcInTable(sTable,sGcOld,sGcNew:string);
var sSql:string;
begin
  GEOGET_DB.ParamsClear();
  GEOGET_DB.AddParamText(':gc_old',sGcOld);
  GEOGET_DB.AddParamText(':gc_new',sGcNew);
//{$ifdef DEBUG_HELPER} LDH('Zmena kodu '+sIdOld+'>>'+sIdNew+' ('+stable+')');{$endif}
  sSql:='UPDATE '+sTable+' SET id=:gc_new WHERE id=:gc_old';
  GEOGET_DB.ExecSQL(sSql);
end;

function CmpGetOld(sLabId:string):boolean;
var s:string;
    g:TGeo;
    j:integer;
begin
  {$ifdef DEBUG_HELPER} LDH('CmpGetOld(): start ########################'); {$endif}
  Result:=false;
  //zjistime informace o labkach v databazi
  rCmpOld.sLabId:=''; //predpokladame, ze serie neni v databazi
  rCmpOld.sSerieName:='';
  rCmpOld.nCount:=0;
  rCmpOld.bCoord:=true;
  s:=GcFromLabId(sLabId);
  {$ifdef DEBUG_HELPER} LDH('CmpGetOld(): s='+s+' ########################'); {$endif}
  if(s='') then begin Result:=true; exit; end; //neni co delat, serie v databazi neni
  rCmpOld.sLabId:=rCmpNew.sLabId;
  g:=TGeo.Create();
  try
    while(s<>'') do begin //vsechny labky serie v databazi
      rCmpOld.Items[rCmpOld.nCount].sGc:=Fetch(s,',');
      g.LoadByGc(rCmpOld.Items[rCmpOld.nCount].sGc);
      if(rCmpOld.sSerieName='') then rCmpOld.sSerieName:=SerieNameFromName(g.Name);
      //jmeno pro porovnani prevedeme na ASCII a mala nismena
      rCmpOld.Items[rCmpOld.nCount].sName:=LowerCase(UtfToAscii(LabNameFromName(g.Name)));
      rCmpOld.Items[rCmpOld.nCount].sLabIdOrd:=g.Guid;
      rCmpOld.Items[rCmpOld.nCount].sCoord:=g.GetCoord();
      rCmpOld.Items[rCmpOld.nCount].idx:=-1;
      rCmpOld.Items[rCmpOld.nCount].iCmpType:=0;
      rCmpOld.Items[rCmpOld.nCount].iOk:=0;
      for j:=0 to rCmpOld.nCount-1 do begin
        if(rCmpOld.Items[rCmpOld.nCount].sCoord=rCmpOld.Items[j].sCoord) then rCmpOld.bCoord:=false;
      end;
      Inc(rCmpOld.nCount);
    end;
  finally
    g.Free();
  end;
  //{$ifdef DEBUG_HELPER} PrintCmp(rCmpOld,'CmpOld'); {$endif}
  Result:=true;
end;

function CmpGetNew(sFile:string):boolean;
var s,sLat,sLon:string;
    bLabIdOrd:boolean;
    i,j:integer;
    x,y:extended;
begin
  Result:=false;
  rCmpNew.sSerieName:='';
  rCmpNew.bCoord:=true;
  //nastavime informace o labkach v GPX souboru
  s:=FileToString(sFile);
  bLabIdOrd:=(Pos('guid=',s)>0); //v serii je LabIdOrd, jedinecne ID labky
  i:=0;
  while(s<>'') do begin
    Fetch(s,'<wpt lat="');    sLat:=Fetch(s,'"');
    if(s='') then break;
    if(i>=MAX_LAB) then begin
      Log('ERR: soubor se serii obsahuje vic nez '+IntToStr(MAX_LAB)
        +' labek, nelze jej spolehlive zpracovat.');
      exit;
    end;
    Fetch(s,'lon="');         sLon:=Fetch(s,'"');
    sLat:=sLat+', '+sLon;
    ParseWgsStr(sLat,x,y);
    rCmpNew.Items[i].sCoord:=FormatCoordNum(x,y);
    Fetch(s,'<name>');
    rCmpNew.Items[i].sGc:=Fetch(s,'</name>');
    if(bLabIdOrd) then begin
      Fetch(s,'guid=');
      rCmpNew.Items[i].sLabIdOrd:=Fetch(s,'</url>');
    end
    else rCmpNew.Items[i].sLabIdOrd:='';
    Fetch(s,'<groundspeak:name><![CDATA[');
    sLon:=Fetch(s,']]');  //jmeno serie/labky by autor
    //jeste musime ze jmena serie odstranit autora a pro porovnani prevest na ASCII a mala pismena
    rCmpNew.Items[i].sName:=LowerCase(UtfToAscii(LabNameFromName(sLon)));
    if(rCmpNew.sSerieName='') then rCmpNew.sSerieName:=SerieNameFromName(sLon);
    if(i=0) then begin //pridame LabId serie
      Fetch(s,'"LABid"><![CDATA[');
      rCmpNew.sLabId:=Fetch(s,']]');
    end;
    rCmpNew.Items[i].idx:=-1;
    rCmpNew.Items[i].iCmpType:=0;
    rCmpNew.Items[i].iOk:=0;
    for j:=0 to i-1 do begin
      if(rCmpNew.Items[i].sCoord=rCmpNew.Items[j].sCoord) then rCmpNew.bCoord:=false;
    end;
    Inc(i);
  end;
  if(i=0) then begin
    ShowMessage('ERR: Soubor neobsahuje zadnou LABku.'+CRLF+sFile);
    exit;
  end;
  rCmpNew.nCount:=i;
  //{$ifdef DEBUG_HELPER} PrintCmp(rCmpNew,'CmpNew'); {$endif}
  if(rCmpNew.sLabId='') then begin
    Log('ERR: Soubor neobsahuje LabId serie, nelze jej spolehlive zpracovat.'+CRLF+sFile);
    exit;
  end;
  Result:=true;
end;

procedure CmpSwapData(sGcOld, sGcNew:string); //prohodi data u zadanych GC kodu
begin
  if(sGcOld=sGcNew) then exit; //neni co prohazovat
{$ifdef DEBUG_HELPER} LDH('Prohazuji data Stary='+sGcOld+', Novy='+sGcNew); {$endif}
  ChangeGcInTable('geocache',sGcOld,sGcNew);
  ChangeGcInTable('geolist',sGcOld,sGcNew);
  ChangeGcInTable('geolog',sGcOld,sGcNew);
  ChangeGcInTable('geotag',sGcOld,sGcNew);
end;

function CmpChangeGgData:boolean;
var i,j:integer;
    sGcTmp:string;
begin
  Result:=false;  //vraci false, pokud je nejaky problem
  sGcTmp:='LabForGg-'; //GC kod pro docasnou kesku
  //napres zmenime GC kod labek v serii na pracovni
  for i:=0 to rCmpOld.nCount-1 do begin
    RemoveLabTags(rCmpOld.Items[i].sGc);      //smazeme tagy pro tuto kesku
    if(rCmpOld.Items[i].idx<0) then continue; //na toto uz je uzivatel upozornen, vice labek v GG nez v GPX
    //najdeme labku, ktera ma byt na tomto miste
    for j:=0 to rCmpNew.nCount-1 do begin
      if(rCmpNew.Items[j].idx=i) then begin
        if(rCmpOld.Items[i].sGc=rCmpNew.Items[j].sGc) then begin
          rCmpNew.Items[j].iOk:=1;
          continue; //neni treba prohazovat
        end;
        CmpSwapData(rCmpOld.Items[i].sGc,sGcTmp+IntToStr(j)); //prohodime na pracovni GC kod
        break;
      end;
    end;
  end;
  //ted zmenime pracovni GC kod na ten novy podle GPX
  for j:=0 to rCmpNew.nCount-1 do begin
    if(rCmpNew.Items[j].idx<0) or (rCmpNew.Items[j].iOk=1) then continue;
    CmpSwapData(sGcTmp+IntToStr(j),rCmpNew.Items[j].sGc); //prohodime z pracovniho a novy GC kod
  end;
  Result:=true;
end;

function CmpSetLabIndex:boolean; //nastavi u kazde labky poradi, v kterem je v te druhe stukture
                                  //vraci true, pokud je vse OK
var iTyp,n,i,j:integer;
    b:boolean;
begin
  //!!!!! nestaci zkontrolovat GC kody labek, protoze mohou byt stejne, ale
  //!!!!! jejich obsah muze byt ruzny
  //najdeme shodne labky bez ohledu na GC, porovnavame v poradi sLabIdOrd, sName, sCoord
  n:=0; //zadna vyresena labka
  for iTyp:=1 to 3 do begin //testujeme napred LabIdOrd, pak souradnice a pak jmeno
    //pokud jsou v nektere ze serii shodne souradnice, nemuzeme podle nich srovnavat poradi labek
    if(iTyp=2) then begin
      if(rCmpOld.bCoord=false) then Log('xx rCmpOld.bCoord=false');
      if(rCmpNew.bCoord=false) then Log('yy rCmpNew.bCoord=false');
      if(rCmpOld.bCoord=false) or (rCmpNew.bCoord=false) then continue;
    end;
    for i:=0 to rCmpNew.nCount-1 do begin
      if(rCmpNew.Items[i].iCmpType>0) then continue; //prirazeno z jineho typu porovnani
      for j:=0 to rCmpOld.nCount-1 do begin
        b:=false;
        //tato labka uz je prirazena, nebudeme ji porovnavat (to pro pripad,
        //ze by byly treba shodne souradnice nebo jmeno u vice labek
        if(rCmpOld.Items[j].iCmpType>0) then continue;
        case iTyp of
        1: if(rCmpNew.Items[i].sLabIdOrd<>'')
             and (rCmpNew.Items[i].sLabIdOrd=rCmpOld.Items[j].sLabIdOrd) then b:=true;
        2: if(rCmpNew.Items[i].sCoord=rCmpOld.Items[j].sCoord) then b:=true;
        3: begin
           //{$ifdef DEBUG_HELPER} LDH('OldName['+IntToStr(j)+']: '+rCmpOld.Items[j].sName+', NewName['+IntToStr(i)+']='+rCmpNew.Items[i].sName);{$endif}
           if(rCmpNew.Items[i].sName=rCmpOld.Items[j].sName) then b:=true;
           //{$ifdef DEBUG_HELPER} LDH('b='+IntToStr(b as integer));{$endif}
           end;
        end;
        if(b) then begin
          rCmpNew.Items[i].iCmpType:=iTyp;  //poznacime typ shody
          rCmpOld.Items[j].iCmpType:=iTyp;
          rCmpNew.Items[i].idx:=j;          //poznacime indexy stare a nove labky
          rCmpOld.Items[j].idx:=i;
          //{$ifdef DEBUG_HELPER} LDH('0: iTyp='+IntToStr(iTyp)+', n='+IntToStr(n)+', i='+IntToStr(i)+', j='+IntToStr(j)+' xxxx shoda');{$endif}
          Inc(n);
          break;
        end;
        //{$ifdef DEBUG_HELPER} LDH('1: iTyp='+IntToStr(iTyp)+', n='+IntToStr(n)+', i='+IntToStr(i)+', j='+IntToStr(j));{$endif}
        if(b) then break; //
      end;
      if(b) then continue; //pro tuto labku shoda nalezena
      if(n=rCmpNew.nCount) then break;
      if(rCmpNew.Items[i].iCmpType>0) then continue;
    end;
    //{$ifdef DEBUG_HELPER} LDH('n='+IntToStr(n));{$endif}
    if(n=rCmpNew.nCount) then break;
  end;
  //vyresime neurcene labky v Old, priradime je k neurcenym labkam v new
  //(zachovame poradi)
  n:=0;
  //PrintCmp(rCmpOld,'Old XXXX');
  //PrintCmp(rCmpNew,'New XXXX');
  for i:=0 to rCmpOld.nCount-1 do begin
    if(rCmpOld.Items[i].iCmpType>0) then continue;
    //{$ifdef DEBUG_HELPER} LDH('  Nevyresene poradi u labky '+IntToStr(i));{$endif}
    for j:=0 to rCmpNew.nCount-1 do begin
      if(rCmpNew.Items[j].iCmpType>0) then continue;
      if(rCmpNew.Items[j].idx<0) then begin
        n:=1; //priznak prirazeni neprirazene labky
        rCmpOld.Items[i].idx:=j;
        rCmpNew.Items[j].idx:=i;
        rCmpOld.Items[i].iCmpType:=4;
        rCmpNew.Items[j].iCmpType:=4;
        //{$ifdef DEBUG_HELPER} LDH('  Nastavuji prvni volnou '+IntToStr(j));{$endif}
        break;
      end;
    end;
  end;
  Log('-------- vysledek porovnani poradi LABek v serii --------');
  PrintCmp(rCmpOld,'Serie v GeoGetu (CmpOld)');
  PrintCmp(rCmpNew,'Serie v GPX souboru (CmpNew)');
  Result:=(n=0); //vraci priznak chyby
end;

function PrepareImportGpx(sFile:string; bRemoveFromList:boolean):boolean;
var i,n:integer;
    s:string;
begin
  //napred upravime GPX, pokud je pozadavek na promitnuti priznaku
  //sekvencni serie do D/T
  SeqToDT(sFile);
  //funkce vraci seznam false, pokud doslo k chybe a import by se nemel provadet
  //v rCmpOld je pak seznam labek k odstraneni ze seznamu
  Result:=false;
  iKeySmartLink:=0;  //inicializace pro mazani tagu
  iKeyFlags:=0;
  rCmpOld.nCount:=0; //inicializace pro porovnavani labek a hledani jejich spravneho poradi
  rCmpNew.nCount:=0;
  rCmpNew.sLabId:='';
  //z GPX souboru nacteme data o serii
  if(not CmpGetNew(sFile)) then exit;   //pri chybe konec
  //z databaze nacteme data o serii
  {$ifdef DEBUG_HELPER} LDH('Pred nactenim CmpGetOld() n='+IntToStr(rCmpOld.nCount));{$endif}
  if(not CmpGetOld(rCmpNew.sLabId)) then exit; //pri chybe koncime
  {$ifdef DEBUG_HELPER} LDH('Po nacteni CmpGetOld()    n='+IntToStr(rCmpOld.nCount));{$endif}
  if(rCmpOld.sLabId='') or (rCmpOld.nCount=0) then begin   //pokud v databazi serie neni, neni co kontrolovat
    Result:=true;
    exit;
  end;
  if(not CmpSetLabIndex()) then begin  //zjistit spravne poradi labek v Old i New strukture
    Log('WARN: Pro nkter LABky ze srie zanajc v GeoGetu kdem '+rCmpOld.Items[0].sGc
      +' se nepodailo najt spravn poad LABek podle importovanho GPX souboru'
      +' a bylo jim piazeno poad podle "volnch" LABek v tomto GPX souboru.');
  end;
  n:=0;
  for i:=0 to rCmpOld.nCount-1 do begin
    if(rCmpOld.Items[i].idx<0) then n:=1;
  end;
  if(n>0) then begin
    Log('WARN: Srie v GeoGetu zanajc v GeoGetu kdem '+rCmpOld.Items[0].sGc
      +' m vce LABek ne v GPX souboru. V GeoGetu zstanou pebyten labky beze zmny.');
  end;
  if(not CmpChangeGgData()) then exit;  //pri chybe se rovnou vratime
  //odstranit kese ze zobrazeneho seznamu (pro jistotu nove i stare)
  if(bRemoveFromList) then begin
    s:='';
    for i:=0 to rCmpOld.nCount-1 do begin
      s:=s+rCmpOld.Items[i].sGc+CRLF;
    end;
    for i:=0 to rCmpNew.nCount-1 do begin
      s:=s+rCmpNew.Items[i].sGc+CRLF;
    end;
    RemoveFromList(s);
  end;
  Result:=true;
end;

function ImportGpxFile(sFile:string):boolean;
begin
  {$ifdef DEBUG_HELPER} LDH('import souboru: '+sFile);{$endif}
  Result:=false;
  if(not PrepareImportGpx(sFile,true)) then exit;  //ukoncime, nelze importovat
{$ifndef NO_IMPORT}
  GeoImportFile(sFile);
{$endif}
  Result:=true;
end;

procedure DownloadAndImportList(sIds:string; bImport:boolean); //stahne zip podle seznamu LabId a importuje
var s,sUrl,sDir,sFile,sRes:string;
    i,j:integer;
    aList:TStringList;
    bErr:boolean;
begin
  //zavolame server s funkci zipFilesById a seznam LabId oddeleny carkou je
  //v promenne fn
  //sestavime parametry
  {$ifdef DEBUG_HELPER} LDH('stazeni jako zip: '+sIds);{$endif}
  s:=AddPostParam('','f','zipFilesById');//napred funkce
  s:=AddPostParam(s,'fn',sIds);
  s:=AddPostSender(s)+PostBoundary();  //odesilatel, podle nej server pozna, ze jde o plugin a ne o formular
  sUrl:=sWEB_URL;
  //{$ifdef DEBUG_HELPER} LDH('##### URL='+sUrl);{$endif}
  GeoBusyCaption('Stahovani gpx soubor ...');
  HttpAsk('POST',sUrl,'multipart/form-data; boundary='+POST_BOUNDARY,s,sRes);
  sDir:=GetOfflineDir()+'Temp';
  DelTree(sDir);
  ForceDirectories(sDir);
  sFile:=GetOfflineDir()+'temp.zip';
  StringToFile(sRes,sFile);
  //rozbalime zip do pripraveneho adresare
  s:='"'+GEOGET_PROGPATH+'7za.exe" e "'+sFile+'" -o"'+sDir+'"';
  {$ifdef DEBUG_HELPER} LDH('spoustim '+s);{$endif}
  i:=RunExec(s);
  {$ifdef DEBUG_HELPER} LDH('vysledek: '+IntToStr(i));{$endif}
  DeleteFile(sFile); //smazeme zip soubor
  if(not bImport) then begin
    ShowMessage('Oznaen srie staeny jako gpx soubory do: '+CRLF+CRLF+sDir+CRLF+CRLF+'(ped ptm importem bude adres vymazn!)');
    exit;
  end;
  GeoBusyCaption('Import gpx soubor ...');
  ProtStart();
  //importujeme vsechny soubory s kontrolou na zmenu GC kodu
  GeoImportBegin(); //inicializujeme import
  aList:=TStringList.Create();
  FileList(sDir, aList);
  //protoze je casove narocne odstraneni seznamu kesi po jedne serii,
  //napred predzpracujeme vsechny gpx a pak vsechny gpx importujeme
  s:='';
  GEOGET_DB.Start('LabForGg','');
  bErr:=false;
  for i:=0 to aList.Count-1 do begin
    GeoBusyKind('Priprava importu souboru '+IntToStr(i+1)+'/'+IntToStr(aList.Count));
    if(GeoBusyTest()) then break; //prerusime, kdyz je pozadavek
    //nasledujici false=neodstranuj ze seznamu, ,odstranime pozdeji vsechny najednou
    if(not PrepareImportGpx(aList[i],false)) then begin //chyba kontroly, nelze soubor bezpecne zpracovat
      bErr:=true;
      RenameFile(aList[i],aList[i]+'_err'); //prejmenujeme soubor
      aList[i]:=''; //aby nedoslo ke smazani souboru
    end
    else begin
      //pridame vsechny labky do seznamu pro odstraneni z okna GG
      //(nove proto, ze uz jsou v databazi zmenene, stare pro jistotu)
      for j:=0 to rCmpOld.nCount-1 do begin
        s:=s+rCmpOld.Items[j].sGc+CRLF;
      end;
      for j:=0 to rCmpNew.nCount-1 do begin
        s:=s+rCmpNew.Items[j].sGc+CRLF;
      end;
    end;
  end;
  GEOGET_DB.Commit('LabForGg');
  ProtEnd();
  GeoBusyKind('Odstraneni starych LABek ze seznamu...');
  if(s<>'') then RemoveFromList(s);   //odstranime seznam vsech labek
  for i:=0 to aList.Count-1 do begin
    if(aList[i]='') then continue;
    GeoBusyKind('Import souboru '+IntToStr(i+1)+'/'+IntToStr(aList.Count));
    if(GeoBusyTest()) then break; //prerusime, kdyz je pozadavek
{$ifndef NO_IMPORT}
    GeoImportFile(aList[i]);      //importujeme soubor
{$endif}
    DeleteFile(aList[i]);
  end;
  if(bErr) then ShowMessage('WARN: Soubory, kter nebylo mon importovat zstaly '
    +'pejmenovan (*_err) v adresi'+CRLF+CRLF+sDir+CRLF+CRLF
    +'!!! Adres bude ped ptm importem vymazn !!!');
  aList.Free();
  //statistiku importu zobrazime jen kdyz neni spusteno z jineho pluginu
  //jinak statistiku vynulujeme
  if(GEOGET_SCRIPTPARENT<>'') then GeoImportBegin()
  else GeoImportEnd(); //zobrazime statistiku importu
end;

function GetSeriesFromServer:string;
var sParams,sUrl:string;
begin
  Result:='';
  sParams:=AddPostParam('','f','getIdGcCoordList');
  sParams:=AddPostSender(sParams)+PostBoundary();  //odesilatel, podle nej server pozna, ze jde o plugin a ne o formular
  sUrl:=AddPassword(sWEBPUB_URL);
  {$ifdef DEBUG_HELPER} LDH('URL='+sUrl);{$endif}
  if(HttpAsk('POST',sUrl,'multipart/form-data; boundary='+POST_BOUNDARY,sParams,Result)) then begin
    Result:=Trim(UtfToAnsi(Result));
    StringToFile(Result,GetServerSeriesPathname());
  end
  else begin
    ShowMessage('ERR: chyba pri nacitani seznamu serii ze serveru.');
    Result:='';
  end;
end;

